searchNodes=[{"doc":"A libcluster strategy for Digital Ocean Droplets. Check out the README to get started.","ref":"Cluster.Strategy.Droplet.html","title":"Cluster.Strategy.Droplet","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Cluster.Strategy.Droplet.html#child_spec/1","title":"Cluster.Strategy.Droplet.child_spec/1","type":"function"},{"doc":"Returns the Droplet metadata top-level index, or specific metadata values. See https://docs.digitalocean.com/products/droplets/how-to/retrieve-droplet-metadata/","ref":"Cluster.Strategy.Droplet.html#get_metadata/1","title":"Cluster.Strategy.Droplet.get_metadata/1","type":"function"},{"doc":"Makes a request to the Digital Ocean API for a list of droplets and recurses through the pages. Will return a parsed list of node names derived from the droplet objects. Expects a full URL and a valid access token to be passed. Logs a warning and returns :error if the API didn't return a successful response.","ref":"Cluster.Strategy.Droplet.html#get_nodes/4","title":"Cluster.Strategy.Droplet.get_nodes/4","type":"function"},{"doc":"Runs a health check for the provided IP address.","ref":"Cluster.Strategy.Droplet.html#healthy?/2","title":"Cluster.Strategy.Droplet.healthy?/2","type":"function"},{"doc":"Starts a GenServer to poll the Digital Ocean API for a list of nodes to add to the cluster. Any nodes currently in the cluster that are no longer returned from the API will be removed from the cluster. Filtering can be done by tag name or Droplet name, but not both. Otherwise an exception will be raised. The current Droplet will be excluded so the node doesn't try to connect to itself. If there is an issue making the API request, the node list is kept as is with no changes. This is because we don't want all the nodes tp disconnect from each other if the Digital Ocean API goes down.","ref":"Cluster.Strategy.Droplet.html#start_link/1","title":"Cluster.Strategy.Droplet.start_link/1","type":"function"},{"doc":"Converts a droplet map returned from the Digital Ocean API to a node name such as :&quot;foobar@127.0.0.1&quot; . Will optionally run a health check on the node to ensure it is ready to connect to the cluster. Returns nil if the health check fails, or if the droplet doesn't have an address for the defined network type and ip version.","ref":"Cluster.Strategy.Droplet.html#to_node_name/2","title":"Cluster.Strategy.Droplet.to_node_name/2","type":"function"},{"doc":"Returns a list of node names as described in to_node_name/2 . Will not return node names for droplets that don't have a status of &quot;active&quot;, or that match the provided ID of the current droplet.","ref":"Cluster.Strategy.Droplet.html#to_node_names/3","title":"Cluster.Strategy.Droplet.to_node_names/3","type":"function"},{"doc":"A libcluster strategy for Digital Ocean Droplets. This clustering strategy will connect all Droplets in your account to the cluster and can optionally be filtered by Droplet name or tag. It works by polling the Digital Ocean API, so a valid access token is required. Installation Configuration Health Checks Releases Firewalls","ref":"readme.html","title":"Libcluster Droplet","type":"extras"},{"doc":"def deps do [ { :libcluster_droplet , &quot;~&gt; 1.0&quot; } ] end config :libcluster , topologies : [ example : [ strategy : Cluster.Strategy.Droplet , config : [ token : System . fetch_env! ( &quot;DIGITALOCEAN_TOKEN&quot; ) , health_check : { :tcp , port : 80 } , tag_name : &quot;foobar&quot; ] ] ]","ref":"readme.html#installation","title":"Libcluster Droplet - Installation","type":"extras"},{"doc":"Key Required Description :token ✓ The Digital Ocean access token used for authenticating with the API. :network Whether to use private or public IP addresses in the node name. Defaults to :private . :ipv6 Whether to use IPv6 addresses in the node name. Defaults to false . :tag_name Droplet tag to filter by when adding to the cluster. Cannot be combined with :name . :name Droplet name to filter by when adding to the cluster. Cannot be combined with :tag_name . :node_basename The base name of the nodes you want to connect to. Defaults to the Droplet name. :health_check Whether to run health checks against the nodes before adding them to the cluster. :polling_interval Number of milliseconds between polls to the API. Defaults to 5_000 .","ref":"readme.html#configuration","title":"Libcluster Droplet - Configuration","type":"extras"},{"doc":"When optionally defined in the config, nodes will not be added to the cluster until they are reported as healthy. :health_check should be a tuple with the first element being the health check type, and the second element being a keyword list of options. Currently the only supported type is :tcp with the following options: :port - The port to run the health check on. Value is required. :timeout - Number of milliseconds to wait before the node is considered unhealthy. Defaults to 500 .","ref":"readme.html#health-checks","title":"Libcluster Droplet - Health Checks","type":"extras"},{"doc":"If you are using distributed Erlang and Mix releases, you'll need to set some environment variables in order for the clustering to work properly. This can be done in the env.sh.eex file generated when running mix release.init , or some other way of setting environment variables. Check out the elixir docs and the release docs for more info. You will need to set these three values: RELEASE_DISTRIBUTION - Set to name so the cluster works across nodes RELEASE_NODE - The full name of the current node (e.g. app@127.0.0.1 ) RELEASE_COOKIE - A type of &quot;password&quot; that allows nodes to connect to the cluster Here is an example env.sh.eex file that makes HTTP requests to the Droplet's metadata API to build the node name: #!/bin/sh # Set this to &quot;public&quot; if you have `network: :public` in your strategy config NETWORK=&quot;private&quot; # Set this to &quot;ipv6&quot; if you have `ipv6: true` in your strategy config IPV=&quot;ipv4&quot; # Droplet hostname is only needed if `:node_basename` is not defined in your strategy config. # Otherwise, replace this curl command with the value defined in `:node_basename`. HOSTNAME=$(curl -s http://169.254.169.254/metadata/v1/hostname) IP_ADDRESS=$(curl -s http://169.254.169.254/metadata/v1/interfaces/$NETWORK/0/$IPV/address) export RELEASE_DISTRIBUTION=name export RELEASE_NODE=$HOSTNAME@$IP_ADDRESS export RELEASE_COOKIE=some-secret-value","ref":"readme.html#releases","title":"Libcluster Droplet - Releases","type":"extras"},{"doc":"Erlang's epmd communicates on port 4369, as well as a random port for each node in the cluster. If your Droplet has a firewall, you will need to add a rule to allow all incoming TCP traffic from other Droplets in the cluster. This can be done dynamically using a tag if you're using a Cloud Firewall . If you want to tighten security even further and only allow specific ports, you can customize the ports used by epmd by adding this to your env.sh.eex file: # This port will be used by epmd instead of port 4369. ERL_EPMD_PORT=9000 # This port will be used by epmd instead of a random port for each node. # Note that if you set this value, you can only run one app instance in each Droplet. ERL_NODE_PORT=9001 case $RELEASE_COMMAND in start*|daemon*) export ELIXIR_ERL_OPTIONS=&quot;-kernel inet_dist_listen_min $ERL_NODE_PORT inet_dist_listen_max $ERL_NODE_PORT&quot; ;; *) ;; esac","ref":"readme.html#firewalls","title":"Libcluster Droplet - Firewalls","type":"extras"}]